/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.squareup.connect.models.SourceApplication;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * Represents the transfer of a quantity of product inventory at a particular time from one location to another.
 */
@ApiModel(description = "Represents the transfer of a quantity of product inventory at a particular time from one location to another.")

public class InventoryTransfer {
  @JsonProperty("id")
  private String id = null;

  @JsonProperty("reference_id")
  private String referenceId = null;

  /**
   * The [InventoryState](#type-inventorystate) for the quantity of items being transfered. See [InventoryState](#type-inventorystate) for possible values
   */
  public enum StateEnum {
    CUSTOM("CUSTOM"),
    
    IN_STOCK("IN_STOCK"),
    
    SOLD("SOLD"),
    
    RETURNED_BY_CUSTOMER("RETURNED_BY_CUSTOMER"),
    
    RESERVED_FOR_SALE("RESERVED_FOR_SALE"),
    
    SOLD_ONLINE("SOLD_ONLINE"),
    
    ORDERED_FROM_VENDOR("ORDERED_FROM_VENDOR"),
    
    RECEIVED_FROM_VENDOR("RECEIVED_FROM_VENDOR"),
    
    IN_TRANSIT_TO("IN_TRANSIT_TO"),
    
    NONE("NONE"),
    
    WASTE("WASTE"),
    
    UNLINKED_RETURN("UNLINKED_RETURN");

    private String value;

    StateEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static StateEnum fromValue(String text) {
      for (StateEnum b : StateEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("state")
  private StateEnum state = null;

  @JsonProperty("from_location_id")
  private String fromLocationId = null;

  @JsonProperty("to_location_id")
  private String toLocationId = null;

  @JsonProperty("catalog_object_id")
  private String catalogObjectId = null;

  @JsonProperty("catalog_object_type")
  private String catalogObjectType = null;

  @JsonProperty("quantity")
  private String quantity = null;

  @JsonProperty("occurred_at")
  private String occurredAt = null;

  @JsonProperty("created_at")
  private String createdAt = null;

  @JsonProperty("source")
  private SourceApplication source = null;

  @JsonProperty("employee_id")
  private String employeeId = null;

  public InventoryTransfer id(String id) {
    this.id = id;
    return this;
  }

   /**
   * A unique ID generated by Square for the [InventoryTransfer](#type-inventorytransfer).
   * @return id
  **/
  @ApiModelProperty(value = "A unique ID generated by Square for the [InventoryTransfer](#type-inventorytransfer).")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public InventoryTransfer referenceId(String referenceId) {
    this.referenceId = referenceId;
    return this;
  }

   /**
   * An optional ID provided by the application to tie the [InventoryTransfer](#type-inventorytransfer) to an external system.
   * @return referenceId
  **/
  @ApiModelProperty(value = "An optional ID provided by the application to tie the [InventoryTransfer](#type-inventorytransfer) to an external system.")
  public String getReferenceId() {
    return referenceId;
  }

  public void setReferenceId(String referenceId) {
    this.referenceId = referenceId;
  }

  public InventoryTransfer state(StateEnum state) {
    this.state = state;
    return this;
  }

   /**
   * The [InventoryState](#type-inventorystate) for the quantity of items being transfered. See [InventoryState](#type-inventorystate) for possible values
   * @return state
  **/
  @ApiModelProperty(value = "The [InventoryState](#type-inventorystate) for the quantity of items being transfered. See [InventoryState](#type-inventorystate) for possible values")
  public StateEnum getState() {
    return state;
  }

  public void setState(StateEnum state) {
    this.state = state;
  }

  public InventoryTransfer fromLocationId(String fromLocationId) {
    this.fromLocationId = fromLocationId;
    return this;
  }

   /**
   * The Square ID of the [Location](#type-location) where the related quantity of items were tracked before the transfer.
   * @return fromLocationId
  **/
  @ApiModelProperty(value = "The Square ID of the [Location](#type-location) where the related quantity of items were tracked before the transfer.")
  public String getFromLocationId() {
    return fromLocationId;
  }

  public void setFromLocationId(String fromLocationId) {
    this.fromLocationId = fromLocationId;
  }

  public InventoryTransfer toLocationId(String toLocationId) {
    this.toLocationId = toLocationId;
    return this;
  }

   /**
   * The Square ID of the [Location](#type-location) where the related quantity of items were tracked after the transfer.
   * @return toLocationId
  **/
  @ApiModelProperty(value = "The Square ID of the [Location](#type-location) where the related quantity of items were tracked after the transfer.")
  public String getToLocationId() {
    return toLocationId;
  }

  public void setToLocationId(String toLocationId) {
    this.toLocationId = toLocationId;
  }

  public InventoryTransfer catalogObjectId(String catalogObjectId) {
    this.catalogObjectId = catalogObjectId;
    return this;
  }

   /**
   * The Square generated ID of the [CatalogObject](#type-catalogobject) being tracked.
   * @return catalogObjectId
  **/
  @ApiModelProperty(value = "The Square generated ID of the [CatalogObject](#type-catalogobject) being tracked.")
  public String getCatalogObjectId() {
    return catalogObjectId;
  }

  public void setCatalogObjectId(String catalogObjectId) {
    this.catalogObjectId = catalogObjectId;
  }

  public InventoryTransfer catalogObjectType(String catalogObjectType) {
    this.catalogObjectType = catalogObjectType;
    return this;
  }

   /**
   * The [CatalogObjectType](#type-catalogobjecttype) of the [CatalogObject](#type-catalogobject) being tracked.Tracking is only supported for the `ITEM_VARIATION` type.
   * @return catalogObjectType
  **/
  @ApiModelProperty(value = "The [CatalogObjectType](#type-catalogobjecttype) of the [CatalogObject](#type-catalogobject) being tracked.Tracking is only supported for the `ITEM_VARIATION` type.")
  public String getCatalogObjectType() {
    return catalogObjectType;
  }

  public void setCatalogObjectType(String catalogObjectType) {
    this.catalogObjectType = catalogObjectType;
  }

  public InventoryTransfer quantity(String quantity) {
    this.quantity = quantity;
    return this;
  }

   /**
   * The number of items affected by the transfer as a decimal string. Fractional quantities are not supported.
   * @return quantity
  **/
  @ApiModelProperty(value = "The number of items affected by the transfer as a decimal string. Fractional quantities are not supported.")
  public String getQuantity() {
    return quantity;
  }

  public void setQuantity(String quantity) {
    this.quantity = quantity;
  }

  public InventoryTransfer occurredAt(String occurredAt) {
    this.occurredAt = occurredAt;
    return this;
  }

   /**
   * A client-generated timestamp in RFC 3339 format that indicates when the transfer took place. For write actions, the `occurred_at` timestamp cannot be older than 24 hours or in the future relative to the time of the request.
   * @return occurredAt
  **/
  @ApiModelProperty(value = "A client-generated timestamp in RFC 3339 format that indicates when the transfer took place. For write actions, the `occurred_at` timestamp cannot be older than 24 hours or in the future relative to the time of the request.")
  public String getOccurredAt() {
    return occurredAt;
  }

  public void setOccurredAt(String occurredAt) {
    this.occurredAt = occurredAt;
  }

  public InventoryTransfer createdAt(String createdAt) {
    this.createdAt = createdAt;
    return this;
  }

   /**
   * A read-only timestamp in RFC 3339 format that indicates when Square received the transfer request.
   * @return createdAt
  **/
  @ApiModelProperty(value = "A read-only timestamp in RFC 3339 format that indicates when Square received the transfer request.")
  public String getCreatedAt() {
    return createdAt;
  }

  public void setCreatedAt(String createdAt) {
    this.createdAt = createdAt;
  }

  public InventoryTransfer source(SourceApplication source) {
    this.source = source;
    return this;
  }

   /**
   * Read-only information about the application that initiated the inventory transfer.
   * @return source
  **/
  @ApiModelProperty(value = "Read-only information about the application that initiated the inventory transfer.")
  public SourceApplication getSource() {
    return source;
  }

  public void setSource(SourceApplication source) {
    this.source = source;
  }

  public InventoryTransfer employeeId(String employeeId) {
    this.employeeId = employeeId;
    return this;
  }

   /**
   * The Square ID of the [Employee](#type-employee) responsible for the inventory transfer.
   * @return employeeId
  **/
  @ApiModelProperty(value = "The Square ID of the [Employee](#type-employee) responsible for the inventory transfer.")
  public String getEmployeeId() {
    return employeeId;
  }

  public void setEmployeeId(String employeeId) {
    this.employeeId = employeeId;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    InventoryTransfer inventoryTransfer = (InventoryTransfer) o;
    return Objects.equals(this.id, inventoryTransfer.id) &&
        Objects.equals(this.referenceId, inventoryTransfer.referenceId) &&
        Objects.equals(this.state, inventoryTransfer.state) &&
        Objects.equals(this.fromLocationId, inventoryTransfer.fromLocationId) &&
        Objects.equals(this.toLocationId, inventoryTransfer.toLocationId) &&
        Objects.equals(this.catalogObjectId, inventoryTransfer.catalogObjectId) &&
        Objects.equals(this.catalogObjectType, inventoryTransfer.catalogObjectType) &&
        Objects.equals(this.quantity, inventoryTransfer.quantity) &&
        Objects.equals(this.occurredAt, inventoryTransfer.occurredAt) &&
        Objects.equals(this.createdAt, inventoryTransfer.createdAt) &&
        Objects.equals(this.source, inventoryTransfer.source) &&
        Objects.equals(this.employeeId, inventoryTransfer.employeeId);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, referenceId, state, fromLocationId, toLocationId, catalogObjectId, catalogObjectType, quantity, occurredAt, createdAt, source, employeeId);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class InventoryTransfer {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    referenceId: ").append(toIndentedString(referenceId)).append("\n");
    sb.append("    state: ").append(toIndentedString(state)).append("\n");
    sb.append("    fromLocationId: ").append(toIndentedString(fromLocationId)).append("\n");
    sb.append("    toLocationId: ").append(toIndentedString(toLocationId)).append("\n");
    sb.append("    catalogObjectId: ").append(toIndentedString(catalogObjectId)).append("\n");
    sb.append("    catalogObjectType: ").append(toIndentedString(catalogObjectType)).append("\n");
    sb.append("    quantity: ").append(toIndentedString(quantity)).append("\n");
    sb.append("    occurredAt: ").append(toIndentedString(occurredAt)).append("\n");
    sb.append("    createdAt: ").append(toIndentedString(createdAt)).append("\n");
    sb.append("    source: ").append(toIndentedString(source)).append("\n");
    sb.append("    employeeId: ").append(toIndentedString(employeeId)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

