/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.squareup.connect.models.AdditionalRecipientReceivableRefund;
import com.squareup.connect.models.Error;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;

/**
 * Defines the fields that are included in the response body of a request to the ListAdditionalRecipientReceivableRefunds endpoint.  One of &#x60;errors&#x60; or &#x60;additional_recipient_receivable_refunds&#x60; is present in a given response (never both).
 */
@ApiModel(description = "Defines the fields that are included in the response body of a request to the ListAdditionalRecipientReceivableRefunds endpoint.  One of `errors` or `additional_recipient_receivable_refunds` is present in a given response (never both).")

public class ListAdditionalRecipientReceivableRefundsResponse {
  @JsonProperty("errors")
  private List<Error> errors = new ArrayList<Error>();

  @JsonProperty("receivable_refunds")
  private List<AdditionalRecipientReceivableRefund> receivableRefunds = new ArrayList<AdditionalRecipientReceivableRefund>();

  @JsonProperty("cursor")
  private String cursor = null;

  public ListAdditionalRecipientReceivableRefundsResponse errors(List<Error> errors) {
    this.errors = errors;
    return this;
  }

  public ListAdditionalRecipientReceivableRefundsResponse addErrorsItem(Error errorsItem) {
    this.errors.add(errorsItem);
    return this;
  }

   /**
   * Any errors that occurred during the request.
   * @return errors
  **/
  @ApiModelProperty(value = "Any errors that occurred during the request.")
  public List<Error> getErrors() {
    return errors;
  }

  public void setErrors(List<Error> errors) {
    this.errors = errors;
  }

  public ListAdditionalRecipientReceivableRefundsResponse receivableRefunds(List<AdditionalRecipientReceivableRefund> receivableRefunds) {
    this.receivableRefunds = receivableRefunds;
    return this;
  }

  public ListAdditionalRecipientReceivableRefundsResponse addReceivableRefundsItem(AdditionalRecipientReceivableRefund receivableRefundsItem) {
    this.receivableRefunds.add(receivableRefundsItem);
    return this;
  }

   /**
   * An array of AdditionalRecipientReceivableRefunds that match your query.
   * @return receivableRefunds
  **/
  @ApiModelProperty(value = "An array of AdditionalRecipientReceivableRefunds that match your query.")
  public List<AdditionalRecipientReceivableRefund> getReceivableRefunds() {
    return receivableRefunds;
  }

  public void setReceivableRefunds(List<AdditionalRecipientReceivableRefund> receivableRefunds) {
    this.receivableRefunds = receivableRefunds;
  }

  public ListAdditionalRecipientReceivableRefundsResponse cursor(String cursor) {
    this.cursor = cursor;
    return this;
  }

   /**
   * A pagination cursor for retrieving the next set of results, if any remain. Provide this value as the `cursor` parameter in a subsequent request to this endpoint.  See [Pagination](/basics/api101/pagination) for more information.
   * @return cursor
  **/
  @ApiModelProperty(value = "A pagination cursor for retrieving the next set of results, if any remain. Provide this value as the `cursor` parameter in a subsequent request to this endpoint.  See [Pagination](/basics/api101/pagination) for more information.")
  public String getCursor() {
    return cursor;
  }

  public void setCursor(String cursor) {
    this.cursor = cursor;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ListAdditionalRecipientReceivableRefundsResponse listAdditionalRecipientReceivableRefundsResponse = (ListAdditionalRecipientReceivableRefundsResponse) o;
    return Objects.equals(this.errors, listAdditionalRecipientReceivableRefundsResponse.errors) &&
        Objects.equals(this.receivableRefunds, listAdditionalRecipientReceivableRefundsResponse.receivableRefunds) &&
        Objects.equals(this.cursor, listAdditionalRecipientReceivableRefundsResponse.cursor);
  }

  @Override
  public int hashCode() {
    return Objects.hash(errors, receivableRefunds, cursor);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ListAdditionalRecipientReceivableRefundsResponse {\n");
    
    sb.append("    errors: ").append(toIndentedString(errors)).append("\n");
    sb.append("    receivableRefunds: ").append(toIndentedString(receivableRefunds)).append("\n");
    sb.append("    cursor: ").append(toIndentedString(cursor)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

