/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.squareup.connect.models.Error;
import com.squareup.connect.models.Shift;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;

/**
 * The response to a request for &#x60;Shift&#x60; objects. Contains the requested &#x60;Shift&#x60; objects. May contain a set of &#x60;Error&#x60; objects if the request resulted in errors.
 */
@ApiModel(description = "The response to a request for `Shift` objects. Contains the requested `Shift` objects. May contain a set of `Error` objects if the request resulted in errors.")

public class SearchShiftsResponse {
  @JsonProperty("shifts")
  private List<Shift> shifts = new ArrayList<Shift>();

  @JsonProperty("cursor")
  private String cursor = null;

  @JsonProperty("errors")
  private List<Error> errors = new ArrayList<Error>();

  public SearchShiftsResponse shifts(List<Shift> shifts) {
    this.shifts = shifts;
    return this;
  }

  public SearchShiftsResponse addShiftsItem(Shift shiftsItem) {
    this.shifts.add(shiftsItem);
    return this;
  }

   /**
   * Shifts
   * @return shifts
  **/
  @ApiModelProperty(value = "Shifts")
  public List<Shift> getShifts() {
    return shifts;
  }

  public void setShifts(List<Shift> shifts) {
    this.shifts = shifts;
  }

  public SearchShiftsResponse cursor(String cursor) {
    this.cursor = cursor;
    return this;
  }

   /**
   * Opaque cursor for fetching the next page.
   * @return cursor
  **/
  @ApiModelProperty(value = "Opaque cursor for fetching the next page.")
  public String getCursor() {
    return cursor;
  }

  public void setCursor(String cursor) {
    this.cursor = cursor;
  }

  public SearchShiftsResponse errors(List<Error> errors) {
    this.errors = errors;
    return this;
  }

  public SearchShiftsResponse addErrorsItem(Error errorsItem) {
    this.errors.add(errorsItem);
    return this;
  }

   /**
   * Any errors that occurred during the request.
   * @return errors
  **/
  @ApiModelProperty(value = "Any errors that occurred during the request.")
  public List<Error> getErrors() {
    return errors;
  }

  public void setErrors(List<Error> errors) {
    this.errors = errors;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SearchShiftsResponse searchShiftsResponse = (SearchShiftsResponse) o;
    return Objects.equals(this.shifts, searchShiftsResponse.shifts) &&
        Objects.equals(this.cursor, searchShiftsResponse.cursor) &&
        Objects.equals(this.errors, searchShiftsResponse.errors);
  }

  @Override
  public int hashCode() {
    return Objects.hash(shifts, cursor, errors);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SearchShiftsResponse {\n");
    
    sb.append("    shifts: ").append(toIndentedString(shifts)).append("\n");
    sb.append("    cursor: ").append(toIndentedString(cursor)).append("\n");
    sb.append("    errors: ").append(toIndentedString(errors)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

